#First check if we can compile with ELPA by doing nothing or simply adding stuff to link LINK_LIBRARIES

foreach(TESTLIB_String "" "-lelpa_openmp" "-lelpa" )
if (NOT LAXLIB_USE_ELPA)
   try_compile(LAXLIB_USE_ELPA ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA.f90 LINK_LIBRARIES ${TESTLIB_String})
   if (LAXLIB_USE_ELPA)
      target_link_libraries(lax PUBLIC ${TESTLIB_String})
   endif()
endif()
endforeach()

message("ELPA Library found:${LAXLIB_USE_ELPA}")

#Now check for version of elpa
if (LAXLIB_USE_ELPA)
    set(LAXLIB_USE_ELPA false)
    try_compile(LAXLIB_USE_ELPA_OLD ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA_OLD.f90)
    try_compile(LAXLIB_USE_ELPA_NEW ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA_NEW.f90)
    try_compile(LAXLIB_USE_ELPA_201605003 ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA_201605003.f90)
    try_compile(LAXLIB_USE_ELPA_201605004 ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA_201605004.f90)
    try_compile(LAXLIB_USE_ELPA_201705003 ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA_201705003.f90)
    try_compile(LAXLIB_USE_ELPA_20180525 ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/tests/test_ELPA_20180525.f90)
    message("Version check for ELPA:")
    message("OLD ELPA      : ${LAXLIB_USE_ELPA_OLD}")
    message("NEW ELPA      : ${LAXLIB_USE_ELPA_NEW}")
    message("201605003 ELPA: ${LAXLIB_USE_ELPA_201605003}")
    message("201605004 ELPA: ${LAXLIB_USE_ELPA_201605004}")
    message("201705003 ELPA: ${LAXLIB_USE_ELPA_201705003}")
    message("20180525  ELPA: ${LAXLIB_USE_ELPA_20180525}")
#Set preprocessor switches
   if (LAXLIB_USE_ELPA_20180525)
       set(LAXLIB_USE_ELPA TRUE)
       target_compile_definitions(lax PUBLIC "CPP_ELPA" "CPP_ELPA2" "CPP_ELPA_20180525")
   elseif (LAXLIB_USE_ELPA_201705003)
       set(LAXLIB_USE_ELPA TRUE)
       target_compile_definitions(lax PUBLIC "CPP_ELPA" "CPP_ELPA2" "CPP_ELPA_201705003")
   elseif (LAXLIB_USE_ELPA_201605004)
       set(LAXLIB_USE_ELPA TRUE)
       target_compile_definitions(lax PUBLIC "CPP_ELPA" "CPP_ELPA2" "CPP_ELPA_201605004")
   elseif (LAXLIB_USE_ELPA_201605003)
       set(LAXLIB_USE_ELPA TRUE)
       target_compile_definitions(lax PUBLIC "CPP_ELPA" "CPP_ELPA2" "CPP_ELPA_201605003")
   elseif (LAXLIB_USE_ELPA_OLD)
       set(LAXLIB_USE_ELPA TRUE)
       target_compile_definitions(lax PUBLIC "CPP_ELPA" "CPP_ELPA2")
   elseif (LAXLIB_USE_ELPA_NEW)
       set(LAXLIB_USE_ELPA TRUE)
       target_compile_definitions(lax PUBLIC "CPP_ELPA" "CPP_ELPA2" "CPP_ELPA_NEW")
   endif()
endif()
